## Defining baz and overloading functions

classdef baz
  properties
    val = 0;
  endproperties
  
  methods
    function b = baz ()
      b.val = 7; # Arbitrary value
    endfunction
    
    function display (b)
      printf ('baz of value %i\n', b.val);
    endfunction
    
    function [p, varargout] = size (s, varargin)
      p = [17 32]; # Arbitrary numbers
      
      if nargin > 2
        error('size: only two arguments are allowed');
      end
      
      if nargin == 2
        dim = varargin{1};
        if ! isa(dim, 'double') || fix (dim(1)) != dim(1)
          error('size: DIM must be integer');
        end
      
        if nargout > 1
          error('size: only one output is possible if DIM is provided');
        end
        
        if (dim(1) == 1) || (dim(1) == 2)
          p = p(dim(1));
          return;
        else
          p = 1;
          return;
        end
      end
      
      if nargout > 1
        varargout    = cell (1, nargout - 1);
        p            = p(1);
        varargout{1} = p(2);
        
        for i = 2 : nargout - 1
          varargout{i} = 1;
        end
      end
    endfunction
    
  endmethods
endclassdef